/**
 * @apicart/vue-components v1.0.0-alpha7 
 * (c) 2018-2020 Apicart Company
 * Released under the MIT License.
 */

(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@apicart/core-sdk')) :
    typeof define === 'function' && define.amd ? define(['@apicart/core-sdk'], factory) :
    (global = global || self, global.ApicartBuyButtonWithQuantity = factory(global.Apicart));
}(this, (function (Apicart) { 'use strict';

    Apicart = Apicart && Object.prototype.hasOwnProperty.call(Apicart, 'default') ? Apicart['default'] : Apicart;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var store;
    var getSelectedProduct = function (dataUrl) { return __awaiter(void 0, void 0, void 0, function () {
        var cart, cartEntity, selectedItem;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!store || !store.hasCartHash()) {
                        return [2, null];
                    }
                    return [4, store.getCart()];
                case 1:
                    cart = _a.sent();
                    return [4, cart.getEntity()];
                case 2:
                    cartEntity = _a.sent();
                    selectedItem = cartEntity.findItemByDataUrl(dataUrl);
                    return [2, selectedItem];
            }
        });
    }); };
    var getSelectedProductQuantity = function (dataUrl) { return __awaiter(void 0, void 0, void 0, function () {
        var selectedItem;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getSelectedProduct(dataUrl)];
                case 1:
                    selectedItem = _a.sent();
                    return [2, selectedItem ? selectedItem.getQuantity() : 0];
            }
        });
    }); };
    var script = {
        name: 'apicart-buy-button-with-quantity',
        props: ['product-url'],
        data: function () {
            return {
                quantity: null
            };
        },
        methods: {
            addItem: function () {
                this.quantity++;
                this.updateItemQuantity();
            },
            removeItem: function () {
                this.quantity--;
                this.updateItemQuantity();
            },
            updateItemQuantity: function () {
                return __awaiter(this, void 0, void 0, function () {
                    var selectedItemQuantity, cart;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, getSelectedProductQuantity(this.productUrl)];
                            case 1:
                                selectedItemQuantity = _a.sent();
                                if (this.quantity <= 0) {
                                    this.quantity = 0;
                                }
                                return [4, store.getCart()];
                            case 2:
                                cart = _a.sent();
                                if (this.quantity > selectedItemQuantity) {
                                    cart.addItem(this.productUrl, this.quantity - selectedItemQuantity);
                                }
                                else if (this.quantity < selectedItemQuantity) {
                                    cart.removeItem(this.productUrl, selectedItemQuantity - this.quantity);
                                }
                                return [2];
                        }
                    });
                });
            }
        },
        created: function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            store = Apicart.getConfigParameter('store');
                            _a = this;
                            return [4, getSelectedProductQuantity(this.productUrl)];
                        case 1:
                            _a.quantity = _b.sent();
                            Apicart.Utils.EventDispatcher.addListener('apicart-buy-button-with-quantity-' + this._uid, 'apicart:cart:item:updated', function (cartItem) {
                                if (cartItem.getItem().getDataUrl() !== _this.productUrl) {
                                    return;
                                }
                                _this.quantity = cartItem.getQuantity();
                            });
                            return [2];
                    }
                });
            });
        }
    };

    function styleInject(css, ref) {
      if ( ref === void 0 ) ref = {};
      var insertAt = ref.insertAt;

      if (!css || typeof document === 'undefined') { return; }

      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';

      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z = ".apicart-buy-button-with-quantity{font-family:-apple-system,\"Segoe UI\",Roboto,Oxygen,Ubuntu,Cantarell,\"Helvetica Neue\",Arial,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\";-webkit-font-smoothing:antialiased;box-sizing:border-box;outline:0}.apicart-buy-button-with-quantity *{box-sizing:border-box;outline:0}.apicart-buy-button-with-quantity{display:inline-flex;white-space:nowrap;height:38px}.apicart-buy-button-with-quantity__form{display:inline-flex;align-items:stretch}.apicart-buy-button-with-quantity__quantity-button{width:34px;line-height:38px;border:1px solid #e6e6e7;display:inline-block;vertical-align:middle;text-align:center;cursor:pointer;user-select:none;transition:background-color .15s linear;font-size:20px;outline:0;user-select:none;-webkit-tap-highlight-color:none}.apicart-buy-button-with-quantity__quantity-button:active,.apicart-buy-button-with-quantity__quantity-button:hover{background-color:#e6e6e7}.apicart-buy-button-with-quantity__quantity-field{width:48px;text-align:center;font-size:16px;border:1px solid #e6e6e7;border-right:0;border-left:0;display:inline-block;vertical-align:middle;-moz-appearance:textfield}.apicart-buy-button-with-quantity__quantity-field::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}.apicart-buy-button-with-quantity__pcs{margin-left:8px}.apicart-buy-button-with-quantity__quantity-button--minus{border-radius:2px 0 0 2px}.apicart-buy-button-with-quantity__quantity-button--plus{border-radius:0 2px 2px 0}";
    styleInject(css_248z);

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    /* script */
    const __vue_script__ = script;
    /* template */
    var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"apicart-buy-button-with-quantity"},[_c('span',{staticClass:"apicart-buy-button-with-quantity__form"},[_c('a',{staticClass:"apicart-buy-button-with-quantity__quantity-button apicart-buy-button-with-quantity__quantity-button--minus",attrs:{"role":"button"},on:{"click":_vm.removeItem}},[_c('span',{staticClass:"apicart-icon-minus"})]),_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.quantity),expression:"quantity"}],staticClass:"apicart-buy-button-with-quantity__quantity-field",attrs:{"type":"number","min":"0"},domProps:{"value":(_vm.quantity)},on:{"change":_vm.updateItemQuantity,"input":function($event){if($event.target.composing){ return; }_vm.quantity=$event.target.value;}}}),_c('a',{staticClass:"apicart-buy-button-with-quantity__quantity-button apicart-buy-button-with-quantity__quantity-button--plus",attrs:{"role":"button"},on:{"click":_vm.addItem}},[_c('span',{staticClass:"apicart-icon-plus"})])])])};
    var __vue_staticRenderFns__ = [];

      /* style */
      const __vue_inject_styles__ = undefined;
      /* scoped */
      const __vue_scope_id__ = undefined;
      /* module identifier */
      const __vue_module_identifier__ = undefined;
      /* functional template */
      const __vue_is_functional_template__ = false;
      /* style inject */
      
      /* style inject SSR */
      
      /* style inject shadow dom */
      

      
      const __vue_component__ = normalizeComponent(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        false,
        undefined,
        undefined,
        undefined
      );

    return __vue_component__;

})));
