/**
 * @apicart/vue-components v1.0.0-alpha7 
 * (c) 2018-2020 Apicart Company
 * Released under the MIT License.
 */

(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@apicart/core-sdk'), require('../..'), require('./..')) :
    typeof define === 'function' && define.amd ? define(['@apicart/core-sdk', '../..', './..'], factory) :
    (global = global || self, global.ApicartProductsList = factory(global.Apicart, global.src, global.components));
}(this, (function (Apicart, src, components) { 'use strict';

    Apicart = Apicart && Object.prototype.hasOwnProperty.call(Apicart, 'default') ? Apicart['default'] : Apicart;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var config = {
        list: [],
        descriptionEnabled: true
    };
    var store;
    var productsDownloader = Apicart.VueComponentsProductsDownloader || src.ProductsDownloader;
    var translator = Apicart.VueComponentsTranslator || src.Translator;
    var i18n = translator.getI18n();
    var windowIsDefined = typeof window !== 'undefined';
    var script = {
        name: 'apicart-products-list',
        i18n: i18n,
        components: {
            'apicart-buy-button': windowIsDefined && window.ApicartBuyButton
                ? window.ApicartBuyButton
                : components.ApicartBuyButton,
            'apicart-loader': windowIsDefined && window.ApicartLoader ? window.ApicartLoader : components.ApicartLoader
        },
        props: {
            productsList: {
                type: Array,
                default: function () {
                    return [];
                }
            },
            categoryKeyPath: {
                type: String,
                default: 'default'
            }
        },
        computed: {
            preloadedProductsData: function () {
                return productsDownloader.getLoadedProductsData(this.productsList);
            },
            productsLoaded: function () {
                return this.productsData.length > 0;
            }
        },
        data: function () {
            return {
                loadedProductsData: [],
                loaderVisible: false,
                descriptionEnabled: false
            };
        },
        watch: {
            categoryKeyPath: function () {
                this.loadProductsData();
            }
        },
        serverPrefetch: function () {
            return this.loadProductsData();
        },
        methods: {
            loadProductsData: function () {
                return __awaiter(this, void 0, void 0, function () {
                    var products;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                this.loaderVisible = true;
                                return [4, productsDownloader.getProductsData(this.productsList)];
                            case 1:
                                products = _a.sent();
                                this.loaderVisible = false;
                                if (typeof window !== 'undefined') {
                                    this.loadedProductsData = products;
                                }
                                return [2];
                        }
                    });
                });
            }
        },
        created: function () {
            config = Apicart.Utils.Objects.merge(config, Apicart.getConfigParameter('vueComponents.category.products'));
            store = Apicart.getConfigParameter('store');
            this.descriptionEnabled = config.descriptionEnabled;
        },
        mounted: function () {
            if (this.preloadedProductsData.length !== this.productsList.length) {
                this.loadProductsData();
            }
        }
    };

    function styleInject(css, ref) {
      if ( ref === void 0 ) ref = {};
      var insertAt = ref.insertAt;

      if (!css || typeof document === 'undefined') { return; }

      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';

      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z = "@charset \"UTF-8\";.apicart-products__loader{width:100%;text-align:center}.apicart-products__list{display:flex;flex-wrap:wrap;width:100%;margin:0 auto}.apicart-products__product{width:100%;display:flex;flex-direction:column;justify-content:space-between;padding-bottom:30px}@media (min-width:576px){.apicart-products__product{width:calc(100% * (1/2) - 6px);margin-right:6px}}@media (min-width:768px){.apicart-products__product{width:calc(100% * (1/3) - 6px)}}@media (min-width:1200px){.apicart-products__product{width:calc(25% - 6px)}}.apicart-products__product-image{position:absolute;transform:translateX(-50%);top:0;max-width:100%;left:50%;padding:26px;max-height:100%}.apicart-products__product-image-wrapper{display:flex;flex:1;padding-top:100%;position:relative;background:#f2f2f2;border-radius:2px}.apicart-products__product-image-wrapper--without-image::before{content:\"\";font-family:apicart-icons;transform:translateX(-50%) translateY(-50%);top:50%;left:50%;position:absolute;z-index:0;color:#d9d9d9;font-size:100px}.apicart-products__product-info-wrapper{padding:10px}.apicart-products__product-info-line{margin-bottom:12px;font-size:14px;display:block;text-decoration:none;color:inherit}.apicart-products__product-info-line--name{padding:8px 0;text-transform:uppercase}.apicart-products__product-info-line:last-of-type{margin-bottom:0}.apicart-products__product-info-price-buy-button{align-items:center;display:flex;justify-content:space-between;flex-wrap:wrap}.apicart-products__product-info-price{margin:8px 8px 8px 0}";
    styleInject(css_248z);

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    /* script */
    const __vue_script__ = script;
    /* template */
    var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{attrs:{"data-category":_vm.categoryKeyPath}},[(!(_vm.loadedProductsData.length ? _vm.loadedProductsData : _vm.preloadedProductsData).length || _vm.loaderVisible )?_c('div',{staticClass:"apicart-products__loader"},[_c('apicart-loader',{attrs:{"visible":true}})],1):_vm._e(),_c('div',{staticClass:"apicart-products__list"},_vm._l(((_vm.loadedProductsData.length ? _vm.loadedProductsData : _vm.preloadedProductsData)),function(product){return _c('div',{key:product.data.id,staticClass:"apicart-products__product"},[_c('a',{staticClass:"apicart-products__product-image-wrapper",class:{ 'apicart-products__product-image-wrapper--without-image': !product.data.images.primary.url },attrs:{"role":product.pageUrl ? false : 'button',"href":product.pageUrl ? product.pageUrl : false,"aria-label":product.data.name}},[(product.data.images.primary.url)?_c('img',{staticClass:"apicart-products__product-image",attrs:{"src":product.data.images.primary.url,"loading":"lazy","alt":product.data.name}}):_vm._e()]),_c('div',{staticClass:"apicart-products__product-info-wrapper"},[_c('a',{staticClass:"apicart-products__product-info-line apicart-products__product-info-line--name",attrs:{"role":product.pageUrl ? false : 'button',"href":product.pageUrl ? product.pageUrl : false}},[_c('strong',[_vm._v(_vm._s(product.data.name))])]),(_vm.descriptionEnabled && product.data && product.data.description && product.data.description.length)?_c('div',{staticClass:"apicart-products__product-info-line",domProps:{"innerHTML":_vm._s(product.data.description)}}):_vm._e(),_c('div',{staticClass:"apicart-products__product-info-line apicart-products__product-info-price-buy-button"},[_c('span',{staticClass:"apicart-products__product-info-price"},[_vm._v(_vm._s(_vm.$n(product.data.price, 'currency')))]),_c('span',[_c('apicart-buy-button',{attrs:{"productUrl":product.dataUrl}})],1)])])])}),0)])};
    var __vue_staticRenderFns__ = [];

      /* style */
      const __vue_inject_styles__ = undefined;
      /* scoped */
      const __vue_scope_id__ = undefined;
      /* module identifier */
      const __vue_module_identifier__ = undefined;
      /* functional template */
      const __vue_is_functional_template__ = false;
      /* style inject */
      
      /* style inject SSR */
      
      /* style inject shadow dom */
      

      
      const __vue_component__ = normalizeComponent(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        false,
        undefined,
        undefined,
        undefined
      );

    return __vue_component__;

})));
