/**
 * @apicart/vue-components v1.0.0-alpha7 
 * (c) 2018-2020 Apicart Company
 * Released under the MIT License.
 */

(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@apicart/core-sdk'), require('vue'), require('vue-i18n')) :
    typeof define === 'function' && define.amd ? define(['@apicart/core-sdk', 'vue', 'vue-i18n'], factory) :
    (global = global || self, global.ApicartVueComponentsTranslator = factory(global.Apicart, global.Vue, global.VueI18n));
}(this, (function (Apicart, Vue, VueI18n) { 'use strict';

    Apicart = Apicart && Object.prototype.hasOwnProperty.call(Apicart, 'default') ? Apicart['default'] : Apicart;
    Vue = Vue && Object.prototype.hasOwnProperty.call(Vue, 'default') ? Vue['default'] : Vue;
    VueI18n = VueI18n && Object.prototype.hasOwnProperty.call(VueI18n, 'default') ? VueI18n['default'] : VueI18n;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var category = {
    	id: "category",
    	showCategories: "Show categories"
    };
    var checkout = {
    	title: "Checkout",
    	validation: {
    		title: "Please correct the following error(s):",
    		emptyCart: "Your cart is empty. You cannot create an order without adding any products.",
    		missingPaymentMethod: "You must select payment method.",
    		missingShippingMethod: "You must select shipping method."
    	},
    	steps: {
    		continueShopping: "Continue shopping",
    		cartOverview: "Cart overview",
    		paymentAndDelivery: "Payment & Delivery",
    		contactInformation: "Contact information",
    		finishOrder: "Finish order"
    	},
    	summary: {
    		title: "Order summary",
    		paymentMethod: "Payment method",
    		paymentMethodNotSelected: "Not selected",
    		shippingMethod: "Shipping method",
    		shippingMethodNotSelected: "Not selected",
    		taxBase: "Tax base",
    		vat: "Vat",
    		totalPrice: "Total price"
    	},
    	cartOverview: {
    		id: "cart-overview",
    		title: "Cart Overview",
    		taxBase: "Tax Base",
    		vat: "Vat",
    		totalPrice: "Total Price",
    		emptyCart: "Your cart is empty."
    	},
    	contactInformationForm: {
    		id: "contact-information",
    		billing: {
    			id: "billing-information",
    			title: "Billing Information",
    			email: "E-mail",
    			firstName: "Name",
    			lastName: "Surname",
    			town: "Town",
    			zip: "Zip",
    			streetAndNumber: "Street and number"
    		},
    		shipping: {
    			id: "shipping-information",
    			title: "Shipping Information",
    			email: "E-mail",
    			firstName: "Name",
    			lastName: "Surname",
    			company: "Company",
    			town: "Town",
    			zip: "Zip",
    			streetAndNumber: "Street and number"
    		},
    		validation: {
    			requiredFields: "You must fill all contact information fields with the star (*) symbol."
    		},
    		fillShippingInfoButton: "Fill shipping info",
    		requiredFields: "Fields with <strong>*</strong> are required",
    		finishOrderButton: "Finish order"
    	}
    };
    var buyButton = "Add to cart";
    var cartDialog = {
    	id: "cart-dialog",
    	title: "Cart updated"
    };
    var cartDropdown = {
    	id: "cart-dropdown",
    	emptyCart: "Your cart is empty.",
    	toggleButton: "Cart",
    	itemsCount: "Items count",
    	totalPrice: "Total price",
    	button: "Finish order"
    };
    var dialog = {
    	okButton: "Ok"
    };
    var loader = {
    	loading: "Loading..."
    };
    var orderDialog = {
    	id: "order-dialog",
    	order: {
    		success: {
    			title: "Order successfully created!",
    			text: "Your order with variable symbol <strong>{variableSymbol}</strong> and total price <strong>{totalPrice}</strong> has been successfully created.<br>Check your e-mail for recapitulation."
    		},
    		error: {
    			title: "Something terribly wrong happened",
    			text: "We are sorry but your order could not be created.<br>Please contact us."
    		}
    	},
    	payment: {
    		success: {
    			title: "Payment successful!",
    			text: "Your payment for an order with variable symbol <strong>{variableSymbol}</strong> with total amount of <strong>{totalPrice}</strong> was successfully made."
    		},
    		error: {
    			title: "An error occured during payment",
    			text: "Your payment was not made because an error occurred. Please contact us.<br>Error message \"{error}\"."
    		}
    	},
    	closeButton: {
    		ok: "Ok",
    		close: "Close",
    		pay: "Go to payment"
    	}
    };
    var paymentMethodsList = {
    	id: "payment-methods",
    	methodsNotFound: "No payment methods found."
    };
    var shippingMethodsList = {
    	id: "shipping-methods",
    	methodsNotFound: "No shipping methods found."
    };
    var fallbackTranslations = {
    	category: category,
    	checkout: checkout,
    	buyButton: buyButton,
    	cartDialog: cartDialog,
    	cartDropdown: cartDropdown,
    	dialog: dialog,
    	loader: loader,
    	orderDialog: orderDialog,
    	paymentMethodsList: paymentMethodsList,
    	shippingMethodsList: shippingMethodsList
    };

    Vue.use(VueI18n);
    var Translator = (function () {
        function Translator() {
            var _this = this;
            this._config = {
                actualLocale: null,
                fallbackLocale: 'en',
                localization: {},
                localizationFilesUrl: 'https://cdn.jsdelivr.net/npm/@apicart/web-components-localization@1.0.0-alpha7/localization',
                currencyFormats: {
                    en: {
                        currency: {
                            style: 'currency', currency: 'EUR', currencyDisplay: 'symbol', code: 'EUR'
                        }
                    }
                }
            };
            this._i18n = null;
            this._loadedLanguages = ['en'];
            this._processedLanguageFiles = {};
            this._downloadUrlsWithError = [];
            this._loadingLanguagePromise = null;
            this._configurationPromises = null;
            this.configure();
            Apicart.Utils.EventDispatcher.addListener('apicart-vueComponentsTranslator-configure', 'apicart:configure', function () {
                _this.configure();
            });
        }
        Translator.prototype.configure = function (config) {
            if (config === void 0) { config = null; }
            return __awaiter(this, void 0, void 0, function () {
                var configurationPromises, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4, this._configurationPromises];
                        case 1:
                            _c.sent();
                            config = config || Apicart.getConfigParameter('vueComponentsTranslator') || {};
                            this._config = Apicart.Utils.Objects.merge(this._config, config);
                            if (!this._config.actualLocale) {
                                this._config.actualLocale = this.detectLocale();
                            }
                            configurationPromises = [];
                            _b = (_a = configurationPromises).push;
                            return [4, this.loadLocalizationFiles(this._config.actualLocale)];
                        case 2:
                            _b.apply(_a, [_c.sent()]);
                            if (this._config.localization) {
                                configurationPromises.push(this.addLocalization(this._config.localization));
                            }
                            this._configurationPromises = Promise.all(configurationPromises);
                            return [4, this._configurationPromises];
                        case 3:
                            _c.sent();
                            if (this._config.currencyFormats) {
                                this.addNumberFormat(this._config.currencyFormats);
                            }
                            return [2];
                    }
                });
            });
        };
        Translator.prototype.getActualCurrencyConfig = function () {
            var currencyConfig = typeof this.getI18n().numberFormats[this.getActualLocale()] === 'undefined'
                ? this.getI18n().numberFormats[this.getFallbackLocale()]
                : this.getI18n().numberFormats[this.getActualLocale()];
            return typeof currencyConfig === 'undefined' ? {} : currencyConfig.currency;
        };
        Translator.prototype.getActualLocale = function () {
            return this.getI18n().locale;
        };
        Translator.prototype.getFallbackLocale = function () {
            return this.getI18n().fallbackLocale ? this.getI18n().fallbackLocale : this._config.fallbackLocale;
        };
        Translator.prototype.getI18n = function () {
            if (!this._i18n) {
                var messages = Apicart.Storage.getItem('apicart-localization') || {};
                messages[this._config.fallbackLocale] = fallbackTranslations;
                this._i18n = new VueI18n({
                    locale: this.detectLocale(),
                    fallbackLocale: this._config.fallbackLocale,
                    messages: messages,
                    numberFormats: this._config.currencyFormats || this._config.defaultCurrencyFormats
                });
            }
            return this._i18n;
        };
        Translator.prototype.loadLocalizationFiles = function (lang, url) {
            if (url === void 0) { url = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this._loadingLanguagePromise];
                        case 1:
                            _a.sent();
                            this._loadingLanguagePromise = this.downloadLocalizationFilesContent(lang, url || this._config.localizationFilesUrl + '/' + lang + '.json');
                            return [4, this._loadingLanguagePromise];
                        case 2:
                            _a.sent();
                            return [2, this.setI18nLanguage(lang)];
                    }
                });
            });
        };
        Translator.prototype.addLocalization = function (localization) {
            var _this = this;
            Apicart.Utils.Loops.forEach(localization, function (translationsOrUrl, locale) {
                if (typeof translationsOrUrl === 'string') {
                    _this.loadLocalizationFiles(locale, translationsOrUrl);
                }
                else {
                    _this.mergeLocaleMessages(locale, translationsOrUrl);
                }
            });
        };
        Translator.prototype.addNumberFormat = function (numberFormat) {
            var _this = this;
            Apicart.Utils.Loops.forEach(numberFormat, function (numberFormat, locale) {
                _this.getI18n().mergeNumberFormat(locale, numberFormat);
            });
        };
        Translator.prototype.downloadLocalizationFilesContent = function (locale, url) {
            return __awaiter(this, void 0, void 0, function () {
                var response, loaded, localeObject;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this._loadedLanguages.includes(locale)) {
                                return [2, true];
                            }
                            if (this._downloadUrlsWithError.includes(url)) {
                                return [2, false];
                            }
                            if (!(url in this._processedLanguageFiles)) {
                                this._processedLanguageFiles[url] = Apicart.Utils.Ajax.get(url);
                            }
                            return [4, this._processedLanguageFiles[url]];
                        case 1:
                            response = _a.sent();
                            loaded = response && Apicart.Utils.Objects.isObject(response.data);
                            if (loaded) {
                                localeObject = {};
                                localeObject[locale] = response.data;
                                Apicart.Storage.updateItem('apicart-localization', localeObject);
                                this.mergeLocaleMessages(locale, response.data);
                            }
                            else {
                                Apicart.Utils.Console.error('Localization file "' + url + '" could not be loaded.');
                                this._downloadUrlsWithError.push(url);
                            }
                            this._loadedLanguages.push(locale);
                            return [2, loaded];
                    }
                });
            });
        };
        Translator.prototype.setI18nLanguage = function (lang) {
            this.getI18n().locale = lang;
            if (this.isInBrowser()) {
                document.querySelector('html').setAttribute('lang', lang);
            }
            return lang;
        };
        Translator.prototype.isInBrowser = function () {
            return typeof window !== 'undefined' && typeof document !== 'undefined';
        };
        Translator.prototype.detectLocale = function () {
            if (!this.isInBrowser()) {
                return this._config.fallbackLocale;
            }
            var documentLang = document.documentElement.getAttribute('lang');
            return documentLang ? documentLang : navigator.language || window.navigator.userLanguage;
        };
        Translator.prototype.mergeLocaleMessages = function (locale, messages) {
            this.getI18n().mergeLocaleMessage(locale, messages);
            Apicart.Utils.EventDispatcher.dispatchEvent('apicart:translations:updated');
        };
        return Translator;
    }());
    var Translator$1 = new Translator();

    return Translator$1;

})));
