import '../../assets/fonts/icons/style.css';

import Apicart from '@apicart/core-sdk';
import Payments from '@apicart/payments-sdk';
import { StoreBrowser } from '@apicart/store-sdk/lib';
import Vue from 'vue';
import VueI18n from 'vue-i18n';
import { ProductsDownloader, Translator } from '../../helpers';
import basicEventListeners from '../basicEventListeners';

Apicart.Store = StoreBrowser;
Apicart.Payments = Payments;
Apicart.VueComponentsTranslator = Translator;
Apicart.VueComponentsProductsDownloader = ProductsDownloader;

if (typeof window !== 'undefined') {
	basicEventListeners.init();
	(<any>window).Vue = Vue;
	(<any>window).VueI18n = VueI18n;
}

export default Apicart;
